/*                               -*- Mode: C -*- 
 * parse-misc.c --- miscellaneous functions
 * Author          : Nicolas Anquetil
 * Created On      : Wed Jan 22 11:26:02 1997
 */

# include "parse-misc.h"

char *itoStr(int i)
/******************************************************
 *   allocate memory 
 */
{
  char *str;

  str = (char *)malloc(I2STRMAX);
  sprintf(str, "%d", i);
  return (str);
}


char *expandName(char *name, int count)
/**************************************************
 * function for adding, the identifier no. ahead of the name
 */
{ 
  char *expanded;
  bool  isQuoted = false;
  int   memsize;

  memsize = strlen(name) + I2STRMAX + 1 + 1; /* 1 for `!' and 1 for `\0' */

  isQuoted = (*name == '\'');
  if (isQuoted)   /* name is a quoted string */
	 memsize +=2; /* to put the "count" in quote */

  expanded = (char *)malloc(memsize);
  sprintf(expanded, (isQuoted ? "'%d!'%s" : "%d!%s"), count, name);

  return(expanded);
}


char *truncateName(char *name)
/**************************************************
 * function for removing, the identifier no. ahead of the name.
 */
{
  char *s;
  bool  isQuoted = false;

  isQuoted = (*name == '\'');
  s = name;

  while ( (*s != '!') && (*s != '\0') )
    s++;

  if (*s == '\0')
    return(name);
  else
	/* if quoted: '999!''...'  we need to skip the `!' and the `'' */
    return(s + (isQuoted ? 2 : 1));
}


char *dupString(char *text)
/**************************************************
 * create a duplicate copy  of the String
 */
{
  char *str;
  if (text != NULL) {
    str = (char *)malloc(strlen(text)+1);
    strcpy(str, text);
    return(str);
  } 
  else
    return( NULL);
}
